unit mainprocesstomemo;
// piping problem.
// https://forum.lazarus.freepascal.org/index.php/topic,42385.0/topicseen.html
{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Process, Pipes,
  StrUtils;

Type
  TRuninteractiveState=(waitfornameprompt, waitforbackprompt,waitforpressenter,statefinished);
  { TTestProcesMemoForm }
  tonnewStr = procedure (memproc:Tprocess;s:string) of object;
  TTestProcesMemoForm = class(TForm)
    buipconfig: TButton;
    butestdoit: TButton;
    buremoteipconfig: TButton;
    Memo1: TMemo;
    procedure buipconfigClick(Sender: TObject);
    procedure buremoteipconfigClick(Sender: TObject);
    procedure butestdoitClick(Sender: TObject);
  private
    interstate : TRuninteractiveState;
  public
    procedure ProcessEvent(Sender,Context : TObject;Status:TRunCommandEventCode;const Message:string);
   procedure processstr(memproc:Tprocess;s:string);
  end;

var
  TestProcesMemoForm: TTestProcesMemoForm;

implementation

{$R *.lfm}

{ TProcessMemo }
Type

 TProcessToMemo = class(TProcess)
                            public
                            fmemo : Tmemo;
                            bytesprocessed : integer;
                            fstringsadded : integer;
                            onnewstr : tonnewStr;
                            function ReadInputStream(p:TInputPipeStream;var BytesRead:integer;var DataLength:integer;var Data:string;MaxLoops:integer=10):boolean;override;
                          end;



function RunCommandMemo(const exename:TProcessString;const commands:array of TProcessString;out outputstring:string; Options : TProcessOptions = [];SWOptions:TShowWindowOptions=swoNone;memo:TMemo=nil;runrefresh : TOnRunCommandEvent=nil;onnewstr:tonnewstr=nil ):boolean;
Var
    p : TProcessToMemo;
    i,
    exitstatus : integer;
    ErrorString : String;
begin
  p:=TProcessToMemo.create(nil);
  if Options<>[] then
    P.Options:=Options - [poRunSuspended,poWaitOnExit];
  p.options:=p.options+[poRunIdle];

  P.ShowWindow:=SwOptions;
  p.Executable:=exename;
  if high(commands)>=0 then
   for i:=low(commands) to high(commands) do
     p.Parameters.add(commands[i]);
  p.fmemo:=memo;
  p.OnRunCommandEvent:=runrefresh;
  p.onnewstr:=onnewstr;
  try
    result:=p.RunCommandLoop(outputstring,errorstring,exitstatus)=0;
  finally
    p.free;
  end;
  if exitstatus<>0 then result:=false;
end;

{ TTestProcesMemoForm }

procedure TTestProcesMemoForm.buipconfigClick(Sender: TObject);
var s : string;
begin
  // basic test for ipconfig
  RunCommandMemo('cmd.exe',['/w','/c','ipconfig'],s,[pousepipes],swonone,memo1,ProcessEvent);
end;

procedure TTestProcesMemoForm.buremoteipconfigClick(Sender: TObject);
var s,cmd : string;
begin
  // this commandline needs editing.
  // it is a test because psexec itself also pipes to slave programs.
  cmd := 'c:\utils\pstools\psexec \\nebulonbfrigate -u darthvader -p deathstar -s -h cmd /c (hostname)^&(ipconfig /all)';
  RunCommandMemo('cmd.exe',['/w','/c',cmd],s,[poPassInput,pousepipes],swonone,memo1,ProcessEvent);
  memo1.lines.add(s);
end;

procedure TTestProcesMemoForm.butestdoitClick(Sender: TObject);
var  s : string;
begin
  memo1.lines.clear;
  interstate:=waitfornameprompt;
  RunCommandMemo('testit.exe',[],s,[ponoconsole,pousepipes],swonone,memo1,ProcessEvent,processstr);
end;

procedure TTestProcesMemoForm.ProcessEvent(Sender, Context: TObject;
  Status: TRunCommandEventCode; const Message: string);
begin
  if status in [RunCommandIdle, RunCommandFinished] then
    begin
      if status =RunCommandFinished then
        begin
          memo1.lines.add(' process finished');
        end;
      if tprocesstomemo(sender).fstringsadded>0 then
       begin
         tprocesstomemo(sender).fstringsadded:=0;
//         memo1.lines.add('Handle:'+inttostr(tprocesstomemo(sender).ProcessHandle));
         memo1.refresh;
       end;
      sleep(10);
      application.ProcessMessages;
    end;
end;

procedure streamwrite(t:tStream;const s : ansistring);
begin
 if length(s)>0 then
    t.write(s[1],length(s));
end;

procedure TTestProcesMemoForm.processstr(memproc:Tprocess;s: string);
begin
   case interstate of
     waitfornameprompt:
                          if startstext('enter name',s) then
                             begin
                               streamwrite(memproc.input,'myname'#13#10);
                               interstate:=waitforbackprompt;
                             end;
     waitforbackprompt:
                          if startstext('now write it',s) then
                             begin
                               streamwrite(memproc.input,'emanym'#13#10);
                               interstate:=waitforpressenter;
                             end;
     waitforpressenter:
                          if startstext('press enter',s) then
                             begin
                               streamwrite(memproc.input,#13#10);
                               interstate:=statefinished;
                             end;

     end;

end;

{ TProcessToMemo }


function TProcessToMemo.ReadInputStream(p:TInputPipeStream;var BytesRead:integer;var DataLength:integer;var Data:string;MaxLoops:integer=10):boolean;
var lfpos : integer;
    crcorrectedpos:integer;
    stradded : integer;
    newstr : string;
begin
  Result:=inherited ReadInputStream(p, BytesRead, DataLength, data, MaxLoops);
  if (result) and (bytesread>bytesprocessed)then
    begin
      stradded:=0;
      lfpos:=pos(#10,data,bytesprocessed+1);
      while (lfpos<>0) and (lfpos<=bytesread) do
        begin
          crcorrectedpos:=lfpos;
          if (crcorrectedpos>0) and (data[crcorrectedpos-1]=#13) then
             dec(crcorrectedpos);
          newstr:=copy(data,bytesprocessed+1,crcorrectedpos-bytesprocessed-1);
          fmemo.lines.add(newstr);
          if assigned(onnewstr) then
            onnewstr(self,newstr);
           inc(stradded);
          bytesprocessed:=lfpos;
          lfpos:=pos(#10,data,bytesprocessed+1);
        end;
      inc(fstringsadded,stradded); // check idle event.
    end;
end;

end.

